Subject: 24.3; mysterious (cons nil features) in read-feature

From: Leo Liu <[email-masked]>
Date: Thu, 14 Nov 2013 13:31:21 +0800

So apparently try-/all-/test-completion(s) functions test if COLLECTION
is a function imprecisely. I propose we fix these functions. Objections?

=== modified file 'src/minibuf.c'
--- src/minibuf.c	2013-11-06 04:11:04 +0000
+++ src/minibuf.c	2013-11-14 05:23:53 +0000
@@ -1199,9 +1199,7 @@
     type = (HASH_TABLE_P (collection) ? hash_table
 	    : VECTORP (collection) ? obarray_table
 	    : ((NILP (collection)
-		|| (CONSP (collection)
-		    && (!SYMBOLP (XCAR (collection))
-			|| NILP (XCAR (collection)))))
+		|| (CONSP (collection) && !FUNCTIONP (collection)))
 	       ? list_table : function_table));
   ptrdiff_t idx = 0, obsize = 0;
   int matchcount = 0;
@@ -1460,9 +1458,7 @@
   Lisp_Object allmatches;
   int type = HASH_TABLE_P (collection) ? 3
     : VECTORP (collection) ? 2
-    : NILP (collection) || (CONSP (collection)
-			    && (!SYMBOLP (XCAR (collection))
-				|| NILP (XCAR (collection))));
+    : NILP (collection) || (CONSP (collection) && !FUNCTIONP (collection));
   ptrdiff_t idx = 0, obsize = 0;
   ptrdiff_t bindcount = -1;
   Lisp_Object bucket, tem, zero;
@@ -1691,9 +1687,7 @@
 
   CHECK_STRING (string);
 
-  if ((CONSP (collection)
-       && (!SYMBOLP (XCAR (collection)) || NILP (XCAR (collection))))
-      || NILP (collection))
+  if ((CONSP (collection) && !FUNCTIONP (collection)) || NILP (collection))
     {
       tem = Fassoc_string (string, collection, completion_ignore_case ? Qt : Qnil);
       if (NILP (tem))

Subject: Re: mysterious (cons nil features) in read-feature
From: Johan Bockgård <[email-masked]>
To: [email-masked]
Date: Wed, 13 Nov 2013 23:30:06 +0100
Newsgroups: gmane.emacs.devel
List-Id: "Emacs development discussions." <emacs-devel.gnu.org>

Leo Liu <[email-masked]> writes:

> I have asked Stefan and Kim and neither has a definite answer. Kim
> pointed me to
> http://lists.gnu.org/archive/html/emacs-devel/2007-04/msg00251.html. I
> have read that and checked the commit logs but I have no answer either.
>
> Anyone else know why (cons nil features)? If not, I plan to remove nil
> and its checking in read-feature.

If you remove it, you will get an error when you try to complete.

The documentation (info "(elisp) Basic Completion") used to allow a list
of symbols as a completion table,

     If COLLECTION is an alist (*note Association Lists::), the
     permissible completions are the elements of the alist that are
     either strings, symbols, or conses whose CAR is a string or symbol.
     Symbols are converted to strings using `symbol-name'.  Other
     elements of the alist are ignored. (Remember that in Emacs Lisp,
     the elements of alists do not _have_ to be conses.)  In
     particular, a list of strings or symbols is allowed, even though
     we usually do not think of such lists as alists.

However this did (and still does) in fact only work if the first symbol
in the list is `nil' (or is not a symbol at all).

Later the documentation was "fixed" to say,

     If COLLECTION is an list [sic], the permissible completions are
     specified by the elements of the list, each of which should be
     either a string, or a cons cell whose CAR is either a string or a
     symbol (a symbol is converted to a string using `symbol-name').
     If the list contains elements of any other type, those are ignored.

But this is not true either, since symbols are not ignored. (If the
first symbol is `nil', completion works. With any other symbol (except
`lambda'), it gives an invalid-function error.)